//**********************************************************************
/*
@@tr`qseXgipeBtj 
*/
//**********************************************************************
//֐錾
extern  void    main();
extern  short   parity_check(char dt);
extern  void    UART1_Write_Text_Ex(char *UART_text);
extern  void    UART1_Write_Ex(char _data);
extern  char    UART1_Read_Ex();
extern  void    UART1_Set_Parity_Mode(short parity_mode);
extern  short   UART1_error;
//**********************************************************************
//}N`
//LCD
sbit  LCD_RS  at  RB6_bit;
sbit  LCD_EN  at  RB7_bit;
sbit  LCD_D7  at  RA1_bit;
sbit  LCD_D6  at  RA0_bit;
sbit  LCD_D5  at  RA7_bit;
sbit  LCD_D4  at  RA6_bit;
sbit  LCD_RS_Direction  at  TRISB6_bit;
sbit  LCD_EN_Direction  at  TRISB7_bit;
sbit  LCD_D7_Direction  at  TRISA1_bit;
sbit  LCD_D6_Direction  at  TRISA0_bit;
sbit  LCD_D5_Direction  at  TRISA7_bit;
sbit  LCD_D4_Direction  at  TRISA6_bit;
//switch
sbit  SW  at  RA5_bit;
sbit  SW_Direction  at  TRISA5_bit;
#define  ON           0
#define  OFF          1
//other
#define  WORD         unsigned  int
#define  BYTE         unsigned  short
//
#define  EVEN_PARITY  0
#define  ODD_PARITY   1
#define  NON_PARITY   2
//**********************************************************************
//C֐ 
void    main()
{
        char    rd, mode = NON_PARITY;
        char    buf[16];
        //
        OSCCON = 0b01110000;
        ANSEL  = 0b00000000;
        //
        SW_Direction = 1;
        //kbc 
        Lcd_Init();
        Lcd_Cmd(_LCD_CLEAR);
        Lcd_Cmd(_LCD_CURSOR_OFF);
        Lcd_Out(1, 1, "USART test");
        Delay_ms(1000);
        Lcd_Cmd(_LCD_CLEAR);
        //
        UART1_Init(9600);
        UART1_Set_Parity_Mode(NON_PARITY);
        Lcd_Out(1, 1, "NON_PARITY ");
        UART1_Write_Text_Ex("JF3SFB\r\n");
        //
        strcpy(buf, "[?]--->");
        Lcd_Out(2, 1, buf);
        //
        while (1) {
                //GR[obNiMMj 
                if (UART1_Data_Ready() == 1) { 
                        rd = UART1_Read_Ex();
                        Lcd_Chr(2, 2, rd);
                        if (UART1_error == 0) {
                                Lcd_Out(2, 8, "OK!");
                        } else {
                                Lcd_Out(2, 8, "NG!");
                        }
                        UART1_Write_Ex(rd);
                }
                //peB[h̐؂ւ 
                if (SW == ON) {
                        while (SW != OFF) {
                                Delay_ms(100);
                        }
                        //
                        mode++;
                        if (mode > NON_PARITY) {
                                mode = EVEN_PARITY;
                        }
                        //
                        switch (mode) {
                        case EVEN_PARITY:
                                Lcd_Out(1, 1, "EVEN_PARITY");
                                UART1_Set_Parity_Mode(EVEN_PARITY);
                                break;
                        case ODD_PARITY:
                                Lcd_Out(1, 1, "ODD_PARITY ");
                                UART1_Set_Parity_Mode(ODD_PARITY);
                                break;
                        case NON_PARITY:
                                Lcd_Out(1, 1, "NON_PARITY ");
                                UART1_Set_Parity_Mode(NON_PARITY);
                                break;
                        }
                }
        }
}
//**********************************************************************
short    UART1_parity_mode = NON_PARITY;
short    UART1_error = 0;
//**********************************************************************
//tr`qspeB[hݒ֐ 
void    UART1_Set_Parity_Mode(short parity_mode)
{
        UART1_parity_mode = parity_mode;
        //
        switch (UART1_parity_mode) {
        case EVEN_PARITY:
        case ODD_PARITY:
                TXSTA.TX9 = 1;
                RCSTA.RX9 = 1;        
                break;
        case NON_PARITY:
                TXSTA.TX9 = 0;
                RCSTA.RX9 = 0;        
                break;
        }
}
//**********************************************************************
//peB`FbN֐
short   parity_check(char dt)
{
        short    cnt, cnt2;
        //
        cnt2 = 0;
        for (cnt = 0; cnt < 8; cnt++) {
                if ((dt & 0b00000001) == 1) {
                        cnt2++;
                }
                dt >>= 1;
        }
        if ((cnt2 % 2) == 0) {
                return (EVEN_PARITY);
        } else {
                return (ODD_PARITY);
        }
}
//**********************************************************************
//tr`qsM֐ipeBΉŁj 
void    UART1_Write_Ex(char _data)
{
        switch (UART1_parity_mode) {
        case EVEN_PARITY:
                TXSTA.TX9D = parity_check(_data);
                break;
        case ODD_PARITY:
                TXSTA.TX9D = ~parity_check(_data);
                break;
        case NON_PARITY:
                break;
        }
        UART1_Write(_data);
}
//**********************************************************************
//tr`qsM֐ipeBΉŁj 
char    UART1_Read_Ex()
{
        char    rd;
        //
        rd = UART1_Read();
        switch (UART1_parity_mode) {
        case EVEN_PARITY:
                if (parity_check(rd) == EVEN_PARITY) {
                        if (RCSTA.RX9D == 0) {
                                UART1_error = 0;
                        } else {
                                UART1_error = -1;
                        }
                } else {
                        if (RCSTA.RX9D == 1) {
                                UART1_error = 0;
                        } else {
                                UART1_error = -2;
                        }
                }
                break;
        case ODD_PARITY:
                if (parity_check(rd) == ODD_PARITY) {
                        if (RCSTA.RX9D == 0) {
                                UART1_error = 0;
                        } else {
                                UART1_error = -3;
                        }
                } else {
                        if (RCSTA.RX9D == 1) {
                                UART1_error = 0;
                        } else {
                                UART1_error = -4;
                        }
                }
                break;
        case NON_PARITY:
                UART1_error = 0;
                break;
        }
        return (rd);
}
//**********************************************************************
//tr`qs񑗐M֐ipeBΉŁj 
void    UART1_Write_Text_Ex(char *UART_text)
{
        while (*UART_text != 0x00) {
                UART1_Write_Ex(*UART_text);
                UART_text++;
        }
}
//**********************************************************************